/*
 * Client main module scripts loading part
 * Copyright 2017, 2018 William Lupshenko
 * 
 * This file is a part of TUServer
 * 
 * TUServer is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Pirate Public License, as
 * published by William Lupshenko. See the LICENSE file for more details
 */

game.foldersWithScripts = [
	"",
	"../client/mods/"
];

game.loadScripts = function() {
	for (var i = 0; i < this.foldersWithScripts.length; i++) {
		var currentFolderContents = [];
		try {
			currentFolderContents = fs.readdirSync(
				"Game/" + this.foldersWithScripts[i]
			).filter(function(fileName) {
				if (fileName.indexOf(".js") + 1) {
					return true;
				}
				
				return false;
			});
		} catch (error) {
			alert(new ReferenceError(
				"can't load content folder " +
				this.foldersWithScripts[i] +
				
				" (" + error + ")"
			));
		}
		
		for (var j = 0; j < currentFolderContents.length; j++) {
			try {
				new Function("", fs.readFileSync(
					"Game/" + 
					this.foldersWithScripts[i] +
					currentFolderContents[j],
				"utf-8"))();
			} catch (error) {
				alert(new ReferenceError(
					"can't load script " +
					this.foldersWithScripts[i] +
					currentFolderContents[j] +
					
					" (" + error + ")"
				));
			}
		}
	}
	
	for (var i in game.textures) {
		game.textures[i] = i;
	}
	for (var i in game.sounds) {
		game.sounds[i].sound = i;
	}
};
